import { action, computed, isAction, makeObservable, observable } from 'mobx';
import { getDataMemberNames, getFacetMemberNames, getOperationMemberNames, } from 'skandha';
import { getAdmin } from '../internal/utils';
export const makeCtrObservable = (ctr) => {
    var _a;
    getFacetMemberNames(ctr).forEach((facetName) => {
        var _a;
        const facet = ctr[facetName];
        makeFacetObservable(facet);
        ((_a = getAdmin(facet).effects) !== null && _a !== void 0 ? _a : []).forEach((f) => f());
    });
    try {
        makeObservable(ctr);
    }
    catch (e) {
        // We need to catch the case where ctr has no mobx annotations.
    }
    ((_a = getAdmin(ctr).effects) !== null && _a !== void 0 ? _a : []).forEach((f) => f());
    return ctr;
};
export const makeFacetObservable = (facet) => {
    addActionsToFacet(facet);
    addObservablesAndComputedsToFacet(facet);
    try {
        makeObservable(facet);
    }
    catch (e) {
        // We need to catch the case where ctr has no mobx annotations.
    }
    return facet;
};
const addActionsToFacet = (facet) => {
    getOperationMemberNames(facet).forEach((opName) => {
        if (!isAction(facet[opName])) {
            facet[opName] = action(facet[opName]);
        }
    });
};
const addObservablesAndComputedsToFacet = (facet) => {
    getDataMemberNames(facet).forEach((dataMemberName) => {
        var _a;
        const descriptor = (_a = Object.getOwnPropertyDescriptor(facet, dataMemberName)) !== null && _a !== void 0 ? _a : Object.getOwnPropertyDescriptor(facet.constructor.prototype, dataMemberName);
        if (!descriptor || descriptor.get) {
            computed(facet, dataMemberName);
        }
        else {
            observable(facet, dataMemberName);
        }
    });
};
export const onMakeCtrObservable = (ctr, f) => {
    var _a;
    const ctrAdmin = getAdmin(ctr);
    ctrAdmin.effects = (_a = ctrAdmin.effects) !== null && _a !== void 0 ? _a : [];
    ctrAdmin.effects.push(f);
};
export const onMakeFacetObservable = (facet, f) => {
    var _a;
    const facetAdmin = getAdmin(facet);
    facetAdmin.effects = (_a = facetAdmin.effects) !== null && _a !== void 0 ? _a : [];
    facetAdmin.effects.push(f);
};
